import { existsSync, readFileSync, writeFileSync } from "fs";
import path from "path";
import { GrokMeta } from "./types";

export const STATE_PATH = path.join(
	__dirname,
	__dirname.includes("index.js") ? ".." : "../..",
	"state.json"
);

if (!existsSync(STATE_PATH))
	writeFileSync(STATE_PATH, JSON.stringify({}), "utf-8");

export const state = new Proxy<{
	grokMeta: GrokMeta;
}>(JSON.parse(readFileSync(STATE_PATH, "utf-8")), {
	get(target, prop) {
		const data = readFileSync(STATE_PATH, "utf-8");
		return JSON.parse(data)[prop];
	},
	set(target, prop, value) {
		const data = JSON.parse(readFileSync(STATE_PATH, "utf-8"));
		data[prop] = value;
		writeFileSync(STATE_PATH, JSON.stringify(data));
		return true;
	}
});
